#version 330 core

layout (location = 0) in vec3 pos;

uniform mat4 lightSpaceMatrix;
uniform mat4 model;

const vec4 top = vec4(0, -1, 0, 300);
const vec4 bottom = vec4 (0, 1, 0, 30);
uniform vec4 nearP;

uniform bool culling;

void main() {
    gl_Position = lightSpaceMatrix * model * vec4(pos, 1.0f);

	vec4 worldPos = model * vec4(pos, 1.0f);

	gl_ClipDistance[0] = culling ? dot(worldPos, top) : 1;
	gl_ClipDistance[1] = culling ? dot(worldPos, bottom) : 1;
	gl_ClipDistance[2] = culling ? dot(worldPos, nearP) : 1;
}